//#include <iostream>
#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>


int main(int argc, char** argv)
{
    const char* fd = "/dev/hidraw0";
    ssize_t size = 0;
    unsigned char wBuffer[9] = {0};
    unsigned char rBuffer[63] = {0};
    unsigned char mode = 0;

    printf("JoyWarrior56FR1 Test\n");

   //Argumente auslesen
    if(argc >= 2)
    {
        //Alle Argumente auswerten und
        for(int i=0; i < argc; i++)
        {
            //Mode
            if(strcmp(argv[i], "-m") == 0)
                mode = strtol(argv[i+1], NULL, 16);
        }
    }

    int device = open(fd, O_RDWR);

    if(device < 0)
    {
        printf("device failed!\n");
        return -1;
    }
        //switch mode of JoyWarrior56FR1, by default "normal mode (0)", (1) for "high speed mode".
        printf("device open!\n");
        printf("Write Data...\n");

        wBuffer[0] = 0x00;
        wBuffer[1] = 0x04;
        wBuffer[2] = mode;
        size = write(device, (void*)wBuffer, 9);

        printf("Write size: %d\n", size);

        if(size == -1)
        {
             close(device);
             printf("Write error!\n");
             return -1;
        }

        //Wait for key press to go on
        printf("Press ANY key to continue. Press CTRL+C to exit\n");
        getchar();
        
        do
        {
            size = read(device, &rBuffer, 63);
            //Print raw data
            printf("Size: %d - %02X %02X %02X %02X %02X %02X\n",size, rBuffer[1], rBuffer[2], rBuffer[3], rBuffer[4], rBuffer[5], rBuffer[6]);
        }while(1);


    close(device);
    return 0;
}